import pandas
import tensorflow as tf
import numpy as np
import os.path
import random
import math
#from tensorflow.python.ops import control_flow_ops as cfo
#from tensorflow.python.framework import ops

from generic_qnet import DNNModel

from discrete_deepq_model import DiscreteDeepQ

import time
import sys

DESCRIPTION_MODEL	= "Reinforcement Learning (DeepQ) "

BrainLayers =  [140,120,100,80]
BrainLayersNL = [tf.tanh]*len(BrainLayers)
BrainDropoutKeep = [1.0]*(len(BrainLayers))

discount_rate         = 0.250
exploration_period    =0    
max_experience        =100000 
store_every_nth       =1
train_every_nth       = 1
target_network_update_rate=0.01
random_action_probability=0.010 
minibatch_size        = 200                   
LearningRate          =.00001     
rateMultiplier        = 0.0

BrainLayersNLSTR = []
for b in BrainLayersNL:
        BrainLayersNLSTR.append(b.__name__)

DESCRIPTION=DESCRIPTION_MODEL+" Batch: "+str(minibatch_size)+" RandProb: "+str(random_action_probability)+"  LR: "+str(LearningRate)+"  DR: "+str(discount_rate)+" Brain: "+str(BrainLayers)+"/"+str(BrainDropoutKeep)+"/"+str(BrainLayersNLSTR)

###########################################################################
###########################################################################
  
# ### Main Training Cycle

totalInputs=189
numberActions =3
print "totalInputs",totalInputs
print "numberActions",numberActions

startTime = time.time()

gpu_options = tf.GPUOptions(per_process_gpu_memory_fraction=0.05)
#config=tf.ConfigProto(gpu_options=gpu_options)

# Tensorflow business - it is always good to reset a graph before creating a new controller.
tf.reset_default_graph()

config=tf.ConfigProto(gpu_options=gpu_options)
#config.intra_op_parallelism_threads = 1
#config.inter_op_parallelism_threads = 1
#config.log_device_placement=True
session = tf.InteractiveSession(config=config)

# This little guy will let us run tensorboard
journalist = tf.train.SummaryWriter("/tmp/cpuvsgpu")

lr = tf.Variable(LearningRate, trainable=False, name='lr')

# Brain maps from observation to Q values for different actions.

brain = DNNModel(totalInputs,BrainLayers+[numberActions], BrainLayersNL+[tf.identity],DropoutKeep=BrainDropoutKeep)

optimizer = tf.train.AdamOptimizer(learning_rate=lr)

# DiscreteDeepQ object
current_controller = DiscreteDeepQ(totalInputs, numberActions, brain, optimizer, session,
                                   discount_rate=discount_rate, 
                                   exploration_period=exploration_period,
                                   max_experience=max_experience, 
                                   store_every_nth=store_every_nth, 
                                   train_every_nth=train_every_nth, 
                                   target_network_update_rate=target_network_update_rate,
                                   random_action_probability=random_action_probability,
                                   minibatch_size=minibatch_size,
                                   summary_writer=journalist)


session.run(tf.initialize_all_variables())

# graph was not available when journalist was created  
journalist.add_graph(session.graph)

print "DESCRIPTION: ",DESCRIPTION
session.run(tf.assign(lr,LearningRate)) 

new_observation=np.random.normal(0,1.0,(1,totalInputs))

#Create some random data for "training"
for dataSamplex in range(max_experience):
    action = random.randrange(numberActions)
    reward = random.random()*2.0 -1.0  # -1.0 to +1.0
    observation=np.random.normal(0,1.0,(1,totalInputs))
    current_controller.store(observation, action, reward, new_observation)
    new_observation =  observation

try:
    for game_idx in range(10):
          
        game_iterations = 0

        startTime = time.time()

        for game_iterations in range(2000):
            cost = current_controller.training_step()                

        endTime = time.time()
        print "Game %d: Total Train Time Time=%d s" % 			(game_idx,(endTime-startTime))
 
except KeyboardInterrupt:
    print "Interrupted"    

session.close()

