import math
import tensorflow as tf
#from tensorflow.python.ops import rnn as rnn

class DNNModel(object):
    def __init__(self, input_sizes, hiddens, nonlinearities=None,DropoutKeep=[], scope=None, given_layers=None):
        self.input_sizes = int(input_sizes)
        self.hiddens     = hiddens
        self.input_nonlinearity= nonlinearities
        self.scope = scope or "DNNModel"
        self.DropoutKeep = DropoutKeep + [1.0]*(len(hiddens)-len(DropoutKeep))
        print self.DropoutKeep
        
        assert len(hiddens) == len(nonlinearities), \
                "Number of hiddens must be equal to number of nonlinearities"

    def CreateNetwork(self,Xinputs,reuse=False):    
      with tf.variable_scope("mydnn") as scope:
        if reuse:
            scope.reuse_variables()
            
        self.next_input_size = self.input_sizes 
        self.next_input_tensor = Xinputs
        self.next_input_tensor_train = Xinputs
        self.layer_number =1
        
        for  current_output_size, current_nonlinearity, dropoutkeep in zip(self.hiddens,self.input_nonlinearity,self.DropoutKeep):
            with tf.name_scope("DNNLayer_"+str(self.layer_number)) as scope:
                l_weight = tf.get_variable(str("l"+str(self.layer_number)+"_weight"), shape=[self.next_input_size, current_output_size],
                                            initializer=tf.contrib.layers.xavier_initializer(),dtype=tf.float32)
                l_bias     = tf.get_variable(str("l"+str(self.layer_number)+"_bias"),initializer=tf.zeros_initializer([current_output_size],dtype=tf.float32))
                l_out      = current_nonlinearity(tf.matmul(self.next_input_tensor,l_weight) + l_bias)
                l_out_train= current_nonlinearity(tf.matmul(tf.nn.dropout(self.next_input_tensor_train,dropoutkeep),l_weight) + l_bias)
                self.next_input_tensor = l_out
                self.next_input_tensor_train = l_out_train
                self.next_input_size = current_output_size
                self.layer_number = self.layer_number +1
                     
        self.output = l_out
        self.output_train = self.next_input_tensor_train
        return  self.next_input_tensor ,self.next_input_tensor_train         

        
      